<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypesREM1_4 extends Record {
    public $name = "spc";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cod_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_tip",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "uf",
            'position' => 11,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "cep",
            'position' => 13,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "segmento",
            'position' => 22,
            'size' => 60,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['cod_cons'] = substr($values, 4, 4);
        $newValues['sub_tip'] = substr($values, 8, 2);
        $newValues['uf'] = substr($values, 10, 2);
        $newValues['cep'] = substr($values, 12, 9);
        $newValues['segmento'] = substr($values, 21, 60);
        
        $this->setColumnsValues($newValues);
    }
    
}