<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\NXXX;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeN210_00 extends Record {
    // public $name = "stolen_document_message_alert";

    public $templateColumns = [
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_type_rule",
            'position' => 5,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "num_msg",
            'position' => 7,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "tot_msg",
            'position' => 9,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "tip_doc",
            'position' => 11,
            'size' => 6,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "num_doc",
            'position' => 17,
            'size' => 20,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "motivo",
            'position' => 37,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "data_ocor",
            'position' => 41,
            'size' => 10,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler",
            'position' => 51,
            'size' => 59,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();
        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();

        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['sub_type_rule'] = substr($values, 4, 2);
        $newValues['num_msg'] = substr($values, 6, 2);
        $newValues['tot_msg'] = substr($values, 8, 2);
        $newValues['tip_doc'] = substr($values, 10, 6);
        $newValues['num_doc'] = substr($values, 16, 20);
        $newValues['motivo'] = substr($values, 36, 4);
        $newValues['data_ocor'] = substr($values, 40, 10);
        $newValues['filler'] = substr($values, 50, 59);

        $this->setColumnsValues($newValues);
    }
}